Bug 1037231 - openmpi FTBFS if "-Werror=format-security" flag is used
openmpi FTBFS if "-Werror=format-security" flag is used
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: openmpi (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Doug Ledford
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1038083
  Show dependency treegraph
 
Reported: 2013-12-02 22:26 EST by Dhiru Kholia
Modified: 2014-03-24 23:45 EDT (History)
6 users (show)

See Also:
Fixed In Version: openmpi-1.7.3-2.fc21
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-12-04 12:33:27 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Dhiru Kholia 2013-12-02 22:26:30 EST
Description of problem
----------------------

openmpi fails to build if "-Werror=format-security" flag is used.

...

btl_usnic_module.c:829:5: error: format not a string literal and no format arguments [-Werror=format-security]

...

We are working on a proposal to enable "-Werror=format-security" for all
packages. Once this flag is enabled, GCC will refuse to compile code that could
be vulnerable to a string format security flaw. For more details, please see
https://fedorahosted.org/fesco/ticket/1185 page.

To understand why it is important to fix this, please see
https://fedoraproject.org/wiki/Format-Security-FAQ page.

How to fix this
---------------

The fix for these errors is quite simple. It's a matter of changing a
line like,

   printf(foo);

to read,

   printf("%s", foo);

That's it.

Please fix this issue in rawhide with a patch (which you should submit
to upstream to merge moving forward). Please do a new build with the
fix in rawhide. Other releases do not need to be directly fixed, but
there should be no harm in pushing out this fix/patch with other needed
changes to those branches.

In the event you don't fix this bug before the next mass rebuild,
provenpackagers may step in and update your package(s) to fix this
issue.

How reproducible
----------------

Build openmpi-1.7.3-1.fc21.src.rpm with "-Werror=format-security" flag to reproduce the problem.

To make this process easier, you can use a modified "redhat-rpm-config" package
from http://people.fedoraproject.org/~halfie/artifacts/redhat-rpm-config/ URL.

$ sha256sum redhat-rpm-config-9.1.0-56.fc20.*
faad7594b2080fe76497d0ce50808c905a93dd7b41c1defdde5ca57e3833d3d2  redhat-rpm-config-9.1.0-56.fc20.noarch.rpm
5aa9357174305c7285ffdbc92d7ffe1c07a8a95d5459b930461308f5aad75413  redhat-rpm-config-9.1.0-56.fc20.src.rpm
Comment 1 Orion Poplawski 2013-12-04 12:33:27 EST
Fixed and reported upstream.
Comment 2 Jeff Squyres 2013-12-04 13:45:34 EST
FWIW: This has already been fixed in the OMPI 1.7 branch and will be included in the 1.7.4 release.

The code actually moved to a different .c file -- if you care, here's the new fixed location:

https://svn.open-mpi.org/trac/ompi/browser/trunk/ompi/mca/btl/usnic/btl_usnic_stats.c#L172

Thanks!

Note You need to log in before you can comment on or make changes to this bug.